unit UnMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, clipbrd, Buttons, ComCtrls, StdCtrls, ExtCtrls, ActnList,
  ImgList, ToolWin, Menus;

type
  TfrmMain = class(TForm)
    Memo1: TMemo;
    StatusBar1: TStatusBar;
    ImageList1: TImageList;
    ActionList1: TActionList;
    ACut: TAction;
    ACopy: TAction;
    APaste: TAction;
    ANew: TAction;
    AOpen: TAction;
    ASave: TAction;
    APrint: TAction;
    AFont: TAction;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ASaveAs: TAction;
    FontDialog1: TFontDialog;
    PrintDialog1: TPrintDialog;
    Panel1: TPanel;
    ToolBar1: TToolBar;
    ToolButton4: TToolButton;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    PopupMenu1: TPopupMenu;
    Plaintext1: TMenuItem;
    APlainText: TAction;
    AHTMLFile: TAction;
    APHPFile: TAction;
    HTMLfile1: TMenuItem;
    PHPfile1: TMenuItem;
    ToolButton12: TToolButton;
    MainMenu1: TMainMenu;
    Afqk1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    Plaintext2: TMenuItem;
    HTMLfile2: TMenuItem;
    PHPfile2: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    AAbout: TAction;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    AStr: TAction;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    procedure AOpenExecute(Sender: TObject);
    procedure ASaveAsExecute(Sender: TObject);
    procedure ASaveExecute(Sender: TObject);
    procedure ACutExecute(Sender: TObject);
    procedure ACopyExecute(Sender: TObject);
    procedure APasteExecute(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AFontExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure APlainTextExecute(Sender: TObject);
    procedure APHPFileExecute(Sender: TObject);
    procedure AHTMLFileExecute(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure ANewExecute(Sender: TObject);
    procedure AAboutExecute(Sender: TObject);
    procedure AStrExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetModified(isMod:Boolean);
    procedure chCaption(str:string);
    function NewText:Boolean;
  end;

var
  frmMain: TfrmMain;
  Modified,IsSaved:Boolean;

const
  TEXT_MODIFIED='  !'+#10#13+'?';
  APP_CAPTION='My NotePad by admhome';
  MB_YES=6;
  MB_NO=7;
  MB_CANCEL=2;
  
  DEF_FONT_NAME='Lucida Console';
  DEF_FONT_SIZE=10;

implementation

uses Math, StdConvs, UnAbout;

{$R *.dfm}

procedure TfrmMain.SetModified(isMod:Boolean);
begin
If Modified=True then StatusBar1.Panels[0].Text:='Modified' else StatusBar1.Panels[0].Text:='';
end;

procedure TfrmMain.chCaption(str:string);
begin
frmMain.Caption:=APP_CAPTION+' ['+str+']';
end;

function TfrmMain.NewText:Boolean;
begin
if Modified=True then
  case Application.MessageBox(TEXT_MODIFIED,APP_CAPTION,MB_YESNOCANCEL+MB_ICONEXCLAMATION) of
    2:; // 
    6:ASaveExecute(Application); // 
    7:try
        IsSaved:=False;
        frmMain.Caption:=APP_CAPTION;
        frmMain.Memo1.Clear;
        NewText:=True;
      except NewText:=False;
      end; //
  end
end;

procedure TfrmMain.AOpenExecute(Sender: TObject);
begin
if Modified=True then
  case Application.MessageBox(TEXT_MODIFIED,APP_CAPTION,MB_YESNOCANCEL+MB_ICONEXCLAMATION) of
    2: Exit ; // 
    6:ASaveExecute(Sender); // 
    7:; //
  end;
if OpenDialog1.Execute then begin
  Memo1.Lines.Clear;
  Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
  Modified:=False;
  SetModified(Modified);
  chCaption(OpenDialog1.FileName);
  if (Memo1.Lines[0]='.LOG') or (Memo1.Lines[0]='.log') then begin
    Memo1.Lines.Add(DateToStr(Now)+' '+TimeToStr(Now));
    Modified:=True;
    SetModified(Modified);
  end;
  SaveDialog1.FileName:=OpenDialog1.FileName;
end;
end;

procedure TfrmMain.ASaveAsExecute(Sender: TObject);
begin
if SaveDialog1.Execute then begin
  Memo1.Lines.SaveToFile(SaveDialog1.FileName);
  Modified:=False;
  SetModified(Modified);
  IsSaved:=True;
  chCaption(SaveDialog1.FileName);
end;
end;

procedure TfrmMain.ASaveExecute(Sender: TObject);
begin
//if Modified=True then
  if IsSaved=True then begin
    Memo1.Lines.SaveToFile(SaveDialog1.FileName);
    Modified:=False;
    SetModified(Modified);
    chCaption(SaveDialog1.FileName);
  end else ASaveAsExecute(Sender);
end;

procedure TfrmMain.ACutExecute(Sender: TObject);
begin
Memo1.CutToClipboard;
end;

procedure TfrmMain.ACopyExecute(Sender: TObject);
begin
Memo1.CopyToClipboard;
end;

procedure TfrmMain.APasteExecute(Sender: TObject);
begin
Memo1.PasteFromClipboard;
Modified:=True;
SetModified(Modified);
end;

procedure TfrmMain.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
Modified:=True;
SetModified(Modified);
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if Modified=True then
  case Application.MessageBox(TEXT_MODIFIED,APP_CAPTION,MB_YESNOCANCEL+MB_ICONEXCLAMATION) of
    2:Action:=caNone; // 
    6:ASaveExecute(Sender); // 
    7:; //
  end;
end;

procedure TfrmMain.AFontExecute(Sender: TObject);
begin
if FontDialog1.Execute then Memo1.Font:=FontDialog1.Font;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
if ParamCount>0 then begin
  Memo1.Lines.Clear;
  Memo1.Lines.LoadFromFile(ParamStr(1));
end;
IsSaved:=False;
Modified:=False;
SetModified(Modified);
end;

procedure TfrmMain.APlainTextExecute(Sender: TObject);
begin
if NewText=False then ShowMessage('Can''t create text file!');
Modified:=True;
SetModified(Modified);
end;

procedure TfrmMain.APHPFileExecute(Sender: TObject);
begin
try
  NewText;
  Memo1.Lines.Add('<?php');
  Memo1.Lines.Add('');
  Memo1.Lines.Add('?>');
  Modified:=True;
  SetModified(Modified);
except ShowMessage('Can''t create php file');
end;
end;

procedure TfrmMain.AHTMLFileExecute(Sender: TObject);
begin
try
  NewText;
  Memo1.Lines.Add('<html>');
  Memo1.Lines.Add('<head>');
  Memo1.Lines.Add('  <meta http-equiv="Content-Type" content="text/html; charset=windows-1251">');
  Memo1.Lines.Add('  <title></title>');
  Memo1.Lines.Add('  <meta name="description" content="">');
  Memo1.Lines.Add('  <meta name="keywords" content="">');
  Memo1.Lines.Add('  <meta name="author" content="">');
  Memo1.Lines.Add('  <meta name="generator" content="">');
  Memo1.Lines.Add('</head>');
  Memo1.Lines.Add('<body>');
  Memo1.Lines.Add('');
  Memo1.Lines.Add('');
  Memo1.Lines.Add('</body>');
  Memo1.Lines.Add('</html>');
  Modified:=True;
  SetModified(Modified);
except ShowMessage('Can''t create html file');
end;
end;

procedure TfrmMain.N7Click(Sender: TObject);
begin
Close;
end;

procedure TfrmMain.ANewExecute(Sender: TObject);
begin
//
end;

procedure TfrmMain.AAboutExecute(Sender: TObject);
begin
frmAbout.Show;
end;

procedure TfrmMain.AStrExecute(Sender: TObject);
begin
Memo1.WordWrap:=AStr.Checked;
AStr.Checked:=not AStr.Checked;
end;

end.

